//-----------------------------------------
// LScript Generic template
//
//  Copyright 2005 Mike Green
// dodgy@shortbutpurple.fsnet.co.uk


@version 2.2
@warnings
@script generic
myversion=1.0; 
//V1:
//added creation of envelopes, so this should be the first full version. 
// global values go here
myall=false;
mypos=false;
myrot=false;
mysize=false;

mygroup;
myselect;
l1;
p0,r0,s0;
generic
{
    myall=true;
    mypos=true;
    myrot=true;
    mysize=true;

//    if(!mysource)
//        error("Copy an item's keys first");
    
    myitems=Scene().getSelect();
    if (!myitems)
        error("Please select some items to paste to");

    mysourceid=globalrecall("MGCopyKeys",nil);
    SelectItem(mysourceid.asInt());
    mysource = Scene().firstSelect();
    mygroup = ChannelGroup(mysource.name);

    mytype = recall("MGCPmytype",1);
    mymethod=recall("MGCPmymethod",1);
    mypointtype=recall("MGCPmypointtype",1);
    mypointf=recall("MGCPmypoint",0);

//debug();
    mystartf=Scene().previewstart;
    myendf=Scene().previewend;
    myrange=recall("MGCPmyrange",1);
    mystartf=recall("MGCPmystart",mystartf);
    myendf=recall("MGCPmyend",myendf);

    // perform all processing here

    reqbegin("MG Paste Keys Version:"+myversion);

    i1 = ctlallitems("Source item:",mysource);
    c1 = ctlchoice("Type",mytype,@"Copy","Cut","Delete only"@);
    m1 = ctlchoice("Method",mymethod,@"Insert","Overwrite","Mix"@);
    t0 = ctlchoice("Insert at",mypointtype,@"Current time","Preview Start","Preview End","Custom"@);
    t1 = ctlinteger("Insert point",mypointf);

    fr1 = ctlchoice("Range",myrange,@"Preview","Render","Custom"@);
    fs1 = ctlinteger("Frame Start",mystartf);
    fe1 = ctlinteger("Frame End",myendf);

    sep1=ctlsep();

    a0 = ctlbutton("All Toggle",120,"allselect");
    p0 = ctlbutton("Position Toggle",120,"posselect");
    r0 = ctlbutton("Rotation Toggle",120,"rotselect");
    s0 = ctlbutton("Size Toggle",120,"sizeselect");

    l1 = ctllistbox("Channels",200,250,"chancount","channame","chanselect");

    ctlactive(fr1,"rangeactive",fs1,fe1);
    ctlactive(t0,"pointactive",t1);
    if (!reqpost())
    {
        SelectItem(myitems[1].id);
        for(i=2;i<=myitems.size();i++)
            AddToSelection(myitems[i].id);
        return;
    }

    // get requester control values here
    
    mysource=getvalue(i1);
    mytype=getvalue(c1);
    mymethod=getvalue(m1);
    mypointtype=getvalue(t0);
    mypointf=getvalue(t1);
    
    myrange=getvalue(fr1);
    mystartf=getvalue(fs1);
    myendf=getvalue(fe1);

    mychannels=getvalue(l1);


    reqend();

//store requester values

    store("MGCPmytype",mytype);
    store("MGCPmymethod",mymethod);
    store("MGCPmypointtype",mypointtype);
    store("MGCPmypoint",mypointf);

    store("MGCPmyrange",myrange);
    store("MGCPmystart",mystartf);
    store("MGCPmyend",myendf);


    if(!mychannels)
    {
        SelectItem(myitems[1].id);
        for(i=2;i<=myitems.size();i++)
            AddToSelection(myitems[i].id);
        error("Please select some channels");
    }
// let's do it!

    mypoint=mypointf/Scene().fps;
    if(mypointtype==1)
        mypoint=Scene().currenttime;
    if(mypointtype==2)
        mypoint=Scene().previewstart;
    if(mypointtype==3)
        mypoint=Scene().previewend;

    if(myrange==1)
    {
        mystartf=Scene().previewstart;
        myendf=Scene().previewend;
    }
    if(myrange==2)
    {
        mystartf=Scene().renderstart;
        myendf=Scene().renderend;
    }

    if(mystartf>myendf)
    {
        temp=mystart;
        mystartf=myendf;
        myend=temp;
    }

    mystart=mystartf/Scene().fps;
    myend=myendf/Scene().fps;
    myoffset=myend-mystart;

    i=1;
    mylist=listgroup(mygroup);
    for(j=1;j<=mychannels.size();j++)
    {
        mychanlist[i]=mylist[mychannels[j]];
        i++;
    }

//debug();

    mychanset=copykeys(mysource,mychanlist,mystart,myend);

//=======================================================================================
    if(mytype==1)                                                   // copy
    {   
        if(mymethod==1)                 //insert
        {
            shiftchans(mychanset,myitems,mystart,myend,mypoint);
            pastechans(mysource,mychanset,myitems,mystart,myend,mypoint);
        }
        else if(mymethod==2)             //overwrite
        {
            delchans(mychanset,myitems,mypoint,mypoint + myoffset );
            pastechans(mysource,mychanset,myitems,mystart,myend,mypoint);
        }
        else                            //mix
        {
            pastechans(mysource,mychanset,myitems,mystart,myend,mypoint);
        }
        
    }
    else if(mytype==2)                                               //cut from source
    {    
        if(mymethod==1)                 //insert
        {
            shiftchans(mychanset,myitems,mystart,myend,mypoint);
            pastechans(mysource,mychanset,myitems,mystart,myend,mypoint);
        }
        else if(mymethod==2)             //overwrite
        {
            delchans(mychanset,myitems,mypoint,mypoint + myoffset );
            pastechans(mysource,mychanset,myitems,mystart,myend,mypoint);
        }
        else                            //mix
        {
            pastechans(mysource,mychanset,myitems,mystart,myend,mypoint);
        }
        // delete from source
        for(i=1;i<=myitems.size();i++)
            myitems[i]=nil;
        myitems[1]=mysource;
        myitems.trunc();
        delchans(mychanset,myitems,mystart,myend);
    }
    else                                                            //just delete from source channels
    {
        for(i=1;i<=myitems.size();i++)
            myitems[i]=nil;
        myitems[1]=mysource;
        myitems.trunc();
        delchans(mychanset,myitems,mystart,myend);    
    }
//=============================================================================================
        SelectItem(myitems[1].id);
        for(i=2;i<=myitems.size();i++)
            AddToSelection(myitems[i].id);

    StatusMsg("Copy complete");

}

copykeys:psource,pchannels,pstart,pend
{
    q=1;
    tempgroup=ChannelGroup(psource.name);
    tempchan=tempgroup.firstChannel();
    while(tempchan)
    {
        if(q<=pchannels.size() && tempchan.name==pchannels[q])
        {
            mychanset[q][1]=tempchan.name;
            j=1;
            for(i=1;i<=tempchan.keyCount;i++)
            {
                mykey=tempchan.keys[i];
                if(range(tempchan.getKeyTime(mykey),pstart,pend))
                {
                    mychanset[q][1]=tempchan.name;
                    mychanset[q][2][j][1]=mykey;
                    mychanset[q][2][j][2]=tempchan.getKeyTime(mykey) - pstart;
                    mychanset[q][2][j][3]=tempchan.getKeyValue(mykey);
                    mychanset[q][2][j][4]=tempchan.getKeyCurve(mykey);
                    if (mychanset[q][2][j][4]==CHAN_HERMITE)
                        mychanset[q][2][j][5]=tempchan.getKeyHermite(mykey);
                    else
                        mychanset[q][2][j][5]=@tempchan.getKeyTension(mykey),
                                        tempchan.getKeyContinuity(mykey),
                                        tempchan.getKeyBias(mykey)@;
                    j++;
                }
            }
            q++;
        }
        tempchan=tempgroup.nextChannel();
    }
//debug();
    return(mychanset);
}

pastechansold:pchanset,pitems,pstart,pend,ppoint
{
// shift and copy the keys
    for(p=1;p<=pitems.size();p++)
    {
        mycurrentgroup=ChannelGroup(pitems[p].name);
        if(mycurrentgroup)
        {
            j=1;
            mycurrentchan=mycurrentgroup.firstChannel();
            while(mycurrentchan)
            {
                if(j<=pchanset.size() && mycurrentchan.name==pchanset[j][1])
                {
                    mykeyset=pchanset[j][2];
                    pastekeys(mykeyset,mycurrentchan,ppoint);
                    j++;
                }
                mycurrentchan=mycurrentgroup.nextChannel();
            }
        }
    }

}

pastechans:psource,pchanset,pitems,pstart,pend,ppoint
{
// shift and copy the keys
//debug();

    for(p=1;p<=pitems.size();p++)
    {
        for(i=1;i<=pchanset.size();i++)
        {
            pchanset[i][3]=0;
        }
        mycurrentgroup=ChannelGroup(pitems[p].name);
        if(mycurrentgroup)
        {
            mycurrentchan=mycurrentgroup.firstChannel();
            while(mycurrentchan)
            {
                for(j=1;j<=pchanset.size();j++)
                {
                    if(mycurrentchan.name==pchanset[j][1])
                    {
                        mykeyset=pchanset[j][2];
                        pchanset[j][3]=1;
                        pastekeys(mykeyset,mycurrentchan,ppoint);
                    }
                }
                mycurrentchan=mycurrentgroup.nextChannel();
            }
        }
        //copied keys for existing channels.
        //now make new channels if source is same type as destination. 
        if(psource.genus==pitems[p].genus)
        {
            SelectItem(pitems[p].id);
            for(j=1;j<=pchanset.size();j++)
            {
                if(pchanset[j][3]==0)
                {
//debug();
                    AddEnvelope(pchanset[j][1]);
                }
            }
        //add keys to new channels.
            mycurrentchan=mycurrentgroup.firstChannel();
            while(mycurrentchan)
            {
                for(j=1;j<=pchanset.size();j++)
                {
                    if(mycurrentchan.name==pchanset[j][1])
                    {
                        if(pchanset[j][3]==0)
                        {
                            mykeyset=pchanset[j][2];
                            pastekeys(mykeyset,mycurrentchan,ppoint);
                        }
                    }
                }
                mycurrentchan=mycurrentgroup.nextChannel();
            }

        }
    }

}

shiftchans:pchanset,pitems,pstart,pend,ppoint
{
// shift and copy the keys
    for(p=1;p<=pitems.size();p++)
    {
        mycurrentgroup=ChannelGroup(pitems[p].name);
        if(mycurrentgroup)
        {
            j=1;
            mycurrentchan=mycurrentgroup.firstChannel();
            while(mycurrentchan)
            {
                if(j<=pchanset.size() && mycurrentchan.name==pchanset[j][1])
                {
                    shiftkeys(mycurrentchan,pstart,pend,ppoint);
                    j++;
                }
                mycurrentchan=mycurrentgroup.nextChannel();
            }
        }
    }

}

delchans:pchanset,pitems,pstart,pend
{
// shift and copy the keys
    for(p=1;p<=pitems.size();p++)
    {
        mycurrentgroup=ChannelGroup(pitems[p].name);
        if(mycurrentgroup)
        {
            j=1;
            mycurrentchan=mycurrentgroup.firstChannel();
            while(mycurrentchan)
            {
                if(j<=pchanset.size() && mycurrentchan.name==pchanset[j][1])
                {
                    delkeys(mycurrentchan,pstart,pend);
                    j++;
                }
                mycurrentchan=mycurrentgroup.nextChannel();
            }
        }
    }

}

listgroup:group
{
//debug();
    i=1;
    mychan=mygroup.firstChannel();
    while(mychan)
    {
        mylist[i]=mychan.name;
        mychan=mygroup.nextChannel();
        i++;
    }
    return (mylist);
}

selectall
{
    mygrouplist=listgroup(mygroup);
    for(i=1;i<=mygrouplist.size();i++)
        myselect[i]=i;
    setvalue(l1,myselect);
}

rangeactive:value
{
    if(value==3)
        return (true);
    return (false);
}

pointactive:value
{
    if(value==4)
        return (true);
    return (false);
}

chancount
{
    mygrouplist = listgroup (mygroup);
    return (mygrouplist.size());
}

channame:index
{
    mygrouplist = listgroup (mygroup);
    return (mygrouplist[index]);    
}

chanselect:items
{
    myselect=items;
    return;
}

allselect//:value
{
    if(myall==true)
    {
        myselect=nil;
        mygrouplist = listgroup (mygroup);
        for(i=1;i<=mygrouplist.size();i++)
            myselect[i]=i;
        setvalue(l1,myselect);
        myall=false;
    }
    else
    {
        myselect=nil;
        setvalue(l1,nil);
        myall=true;
    }
    return;
}
posselect//:value
{
    mygrouplist = listgroup (mygroup);
    if(mypos==true)
    {
        j=myselect.size()+1;
        for(i=1;i<=mygrouplist.size();i++)
        {
            if(strleft(mygrouplist[i],8)=="Position")
            {
                myselect[j]=i;
                j++;
            }
        }
        myselect.sortA();
        myselect.reduce();
        setvalue(l1,myselect);
        mypos=false;
    }
    else
    {
//debug();
        for(i=1;i<=myselect.size();i++)
        {
        if(strleft(mygrouplist[myselect[i]],8)=="Position")
            myselect[i]=nil;
        }
        myselect.sortA();
        myselect.pack();
        myselect.trunc();
        if(!myselect||!myselect[1])
        {   
            myselect=nil;
            setvalue(l1,myselect);
        }
        else
        {
            setvalue(l1,myselect);
        }
        mypos=true;
        
    }
    return;
}

rotselect//:value
{
    mygrouplist = listgroup (mygroup);
    if(myrot==true)
    {
        j=myselect.size()+1;
        for(i=1;i<=mygrouplist.size();i++)
        {
            if(strleft(mygrouplist[i],8)=="Rotation")
            {
                myselect[j]=i;
                j++;
            }
        }
        myselect.sortA();
        myselect.reduce();
        setvalue(l1,myselect);
        myrot=false;
    }
    else
    {
        for(i=1;i<=myselect.size();i++)
        {
        if(strleft(mygrouplist[myselect[i]],8)=="Rotation")
            myselect[i]=nil;
        }
        myselect.pack();
        myselect.trunc();
        if(!myselect || !myselect[1])
        {   
            myselect=nil;
            setvalue(l1,myselect);
        }
        else
        {
            setvalue(l1,myselect);
        }
        myrot=true;
        
    }
    return;
}

sizeselect//:value
{
    mygrouplist = listgroup (mygroup);
    if(mysize==true)
    {
        j=myselect.size()+1;
        for(i=1;i<=mygrouplist.size();i++)
        {
            if(strleft(mygrouplist[i],5)=="Scale")
            {
                myselect[j]=i;
                j++;
            }
        }
        myselect.sortA();
        myselect.reduce();
        setvalue(l1,myselect);
        mysize=false;
    }
    else
    {
        for(i=1;i<=myselect.size();i++)
        {
        if(strleft(mygrouplist[myselect[i]],5)=="Scale")
            myselect[i]=nil;
        }
        myselect.pack();
        myselect.trunc();
        if(!myselect || !myselect[1])
        {   
            myselect=nil;
            setvalue(l1,myselect);
        }
        else
        {
            setvalue(l1,myselect);
        }
        mysize=true;
        
    }
    return;
}

shiftkeys:mychan,mystart,myend,mypoint
{
    offset=myend - mystart;
    j=1;
    for(i=1;i<=mychan.keyCount;i++)
    {
        mykey=mychan.keys[i];
        if(mychan.getKeyTime(mykey)>=mypoint)
        {
            mykeyset[j][1]=mykey;
            mykeyset[j][2]=mychan.getKeyTime(mykey) - mystart;
            mykeyset[j][3]=mychan.getKeyValue(mykey);
            mykeyset[j][4]=mychan.getKeyCurve(mykey);
            if (mykeyset[j][4]==CHAN_HERMITE)
                mykeyset[j][5]=mychan.getKeyHermite(mykey);
            else
                mykeyset[j][5]=@mychan.getKeyTension(mykey),mychan.getKeyContinuity(mykey),mychan.getKeyBias(mykey)@;
            j++;
        }
    }
    
    for(i=1;i<=mykeyset.size();i++)
    {
        mychan.deleteKey(mykeyset[i][1]);
    }

    pastekeys(mykeyset,mychan,mypoint+offset + 1/Scene().fps);
    
}

pastekeys:pkeyset,pchan,ppoint
{
    if(!pkeyset)
        return;
    for(i=1;i<=pkeyset.size();i++)
    {
        mynewkey=pchan.createKey(pkeyset[i][2]+ ppoint ,pkeyset[i][3]);
        pchan.setKeyCurve(mynewkey,pkeyset[i][4]);
        if (pkeyset[i][4]==CHAN_HERMITE)
            pchan.setKeyHermite(mynewkey,pkeyset[i][5]);
        else
        {
            pchan.setKeyTension(mynewkey,pkeyset[i][5][1]);
            pchan.setKeyContinuity(mynewkey,pkeyset[i][5][2]);
            pchan.setKeyBias(mynewkey,pkeyset[i][5][3]);
        }
    }
    
}

delkeys:mychan,mystart,myend
{
    j=1;
    for(i=1;i<=mychan.keyCount;i++)
    {
        mykey=mychan.keys[i];
        if(range(mychan.getKeyTime(mykey), mystart, myend))
        {
            mykeyset[j]=mykey;
            j++;
        }
    }
    
    for(i=1;i<=mykeyset.size();i++)
    {
        mychan.deleteKey(mykeyset[i]);
    }   
}








